package it.eng.spagosoa.utils;

import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;

public class SOAPUtils {
	

	
	public static SOAPElement createSOAPMessageFromString(String xmlString) throws Exception {
        SOAPMessage message = MessageFactory.newInstance().createMessage();
        SOAPPart soap = message.getSOAPPart();
        SOAPEnvelope envelope = soap.getEnvelope();
        SOAPBody body = envelope.getBody();
        Document doc = createDOMFromString(xmlString);
        if (doc == null)
            throw new IOException("Problem reading and creating DOM from file,readFileCreateDocument() returned null ");
        SOAPElement element = body.addDocument(doc);
        return element;
    }
	
	public static SOAPElement createSOAPMessageFromFile(String filename) throws Exception {
        SOAPMessage message = MessageFactory.newInstance().createMessage();
        SOAPPart soap = message.getSOAPPart();
        SOAPEnvelope envelope = soap.getEnvelope();
        SOAPBody body = envelope.getBody();
        Document doc = createDOMFromFile(filename);
        if (doc == null)
            throw new IOException("Problem reading and creating DOM from file,readFileCreateDocument() returned null ");
        SOAPElement element = body.addDocument(doc);
        return element;
    }
	
	/**
     * Read a file and create a DOM out of it
     * @param filename the file where the XML is stored
     * @return
     */
    public static Document createDOMFromFile(String filename) throws Exception {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setValidating(false);
        factory.setNamespaceAware(true);
        DocumentBuilder parser = factory.newDocumentBuilder();
        InputStream in = Thread.currentThread().getContextClassLoader().getResourceAsStream(filename);
        Document xml = parser.parse(in);
        in.close();
        return xml;
    }
	
    public static Document createDOMFromString(String xmlString) throws Exception {
        
    	
    	DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setValidating(false);
        factory.setNamespaceAware(true);
        DocumentBuilder parser = factory.newDocumentBuilder();
       
        Document xml = parser.parse(new InputSource(new StringReader(xmlString)));

        return xml;
    }
}
